#! /bin/sh
#----------------------------------------------------------------------------
# Copyright (c) 2004-2005 Sebastian Scholze <webmaster@schlotze.de>
#
# Creation:     2004-04-01  schlotze
# Last Update:	$Id: preinstall.sh 18814 2009-03-27 11:11:13Z schlotze $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#------------------------------------------------------------------------------
# include eislib
. /var/install/include/eislib

#testroot=/home/scholze/root
testroot=''

deinstallfile=$testroot/var/install/deinstall/jdk
olddeinstallfile=$testroot/var/install/deinstall/jdk1.4

# check base version
oldinstalled_version=`/var/install/bin/check-version jdk1.4 1.1.1`
installed_version=`/var/install/bin/check-version jdk 1.1.5`

#
if [ -f $deinstallfile ]
then
	dtou $deinstallfile
fi

mecho -info "looking for (really) old version..."

case "$oldinstalled_version" in
    not-installed ) # wrong version
		mecho "no (really) old version found..."
        ;;
	installed|old )
		# deinstall old software
		if [ -f $olddeinstallfile ]
		then
			mecho "deinstalling previously installed version..."
			sh $olddeinstallfile
		fi
		;;
    * ) # new
		# deinstall old software
		if [ -f $olddeinstallfile ]
		then
			mecho "deinstalling previously installed version..."
			rm -f /usr/lib/libstdc++-libc6.1-1.so.2
			rm -r -f /usr/local/j2sdk1.4*
			rm -r -f /usr/share/doc/jdk1.4
			rm -f /var/install/deinstall/jdk1.4
			rm -f /var/install/packages/jdk1.4
			
			chmod a+r /usr/lib/libstdc++-libc6.2-2.so.3
		fi
        ;;
esac    

mecho -info "looking for old version..."

case "$installed_version" in
    not-installed ) # wrong version
		mecho "no previously installed version found..."
        ;;
	* )
		# deinstall old software
		if [ -f $deinstallfile ]
		then
			mecho "deinstalling previously installed version..."
			sh $deinstallfile

            if [ -d /usr/local/jdk1.6.0 ]
            then
                rm -rf /usr/local/jdk1.6.0
            fi
		fi
		;;
esac    

mecho -info "checking for old environment variables..."
# check for old environment variables in /etc/profile
grep 'JAVA_HOME' /etc/profile >/dev/null 2>&1
res=$?

case $res in
	0) 	# remove environment variable
		grep -v "^JAVA_HOME" /etc/profile >/tmp/profile-tmp
		cp /tmp/profile-tmp /etc/profile
		rm -f /tmp/profile-tmp

		grep -v "^PATH=\$PATH:\$JAVA_HOME/bin" /etc/profile >/tmp/profile-tmp
		cp /tmp/profile-tmp /etc/profile
		rm -f /tmp/profile-tmp
		mecho "old environment variables removed..."
	;;
	*) 	#
		mecho "no old environment variables found..."
	;;
esac

exit 0
